<!DOCTYPE html>
<html lang="ru">
<head>
  <meta charset="UTF-8">
  <title>Заголовок страницы</title>
  <meta name="description" content="Описание для поисковиков" />
  <meta name="keywords" content="ключ, ключ, ключ">
  <link rel="stylesheet" href="style.css">
</head>
<body>
<header>
  <h1>Заголовок прекрасной страницы</h1>
  <nav>Навигация в хэдере</nav>
</header>
<main>
  <article>
    <header><h2>Задание 1</h2></header>
    <section>
    <div class="background">
    </div>
    <p class="warning">
      При мобильном формате, изображения наслаиваются друг на друга.
    </p>
    </section>
  </article>
  <article>
    <header><h2>Задание 2</h2></header>
    <section>
      <p> <img src="./code.png" alt="code" />
      Для многократного использования и декомпозиции, взаимодействие с API вынесено в хуки (hooks — это функция,
      имеющая доступ к состоянию, которая пришла на замену классовым компонентам в React), части которых мы импортируем для получения
      определенных данных. Также для модульности и интеграцией в будущем с другими Git-сервисами, функции для получения данных для отрисовки
      компоненты, которые используют один или несколько хуков, работающих с API, вынесены в отдельные хуки.
      Из-за этого, на уровне компоненты мы всегда взаимодействуем с данными только определенной структуры, для добавления других
      сервисов остается подменить хуки для получения информации с сервера и ее обработки.
      Для взаимодействия с удаленным сервером, необходимо использовать асинхронные функции с ожиданием получения ответа,
      что требует особого внимания.
      В каждом запросе хука, который взаимодействует с API, мы создаем Promise. Это специальный объект,
      который используются для организации асинхронного кода, который содержит будущее значение операции.
      Также можно сказать, что он нам дает «обещание» получить эти данные. После создания промиса, мы можем разрешить его,
      заполнив методами внутри одно из двух полей – успешно выполненный запрос, данные которого можно использовать для
      дальнейшей работы программы (resolve), или второе при возникновении ошибки (reject).
        Для работы с приложением нужна авторизация на сервисе, который используется для получения Git репозиториев.
        На данный момент это GitHub, но есть возможность в будущем интегрировать и другие сервисы, которые работают
        на основе Git. Авторизация происходит с использованием Personal Access Token, который сохраняется в Redux,
        что позволяет запомнить его на условно бесконечное количество времени, пока не будут очищены данные браузера или же пока токен устареет.
      </p>
    </section>
  </article>
  <article class="divs">
    <header><h2>Задание 3</h2></header>
    <!-- Без экранизации - применяется большее кол-во -->
    <section>
      <div>Block 1</div>
      <div>Block 2</div>
      <div>Block 3</div>
      <div>Block 4</div>
      <div>Block 5</div>
      <div>Block 6</div>
      <div>Block 7</div>
      <div>Block 8</div>
      <div>Block 9</div>
      <div>Block 10</div>
      <div>Block 11</div>
      <div>Block 12</div>
      <div>Block 13</div>
      <div>Block 14</div>
      <div>Block 15</div>
      <div>Block 16</div>
      <div>Block 17</div>
      <div>Block 18</div>
      <div>Block 19</div>
      <div>Block 20</div>
    </section>
    <!-- Экранируем ссылками, чтобы сработали определенные псевдоклассы (не срабатывают first/last-child)  -->
    <section>
      <a href="https://validator.w3.org">Валидатор</a>
      <div>2Block 1</div>
      <div>2Block 2</div>
      <div>2Block 3</div>
      <div>2Block 4</div>
      <a href="https://validator.w3.org">Валидатор2</a>
    </section>
    <!-- Единственный ребенок -->
    <section>
      <div>3Block1</div>
    </section>
  </article>
</main>
<footer>
  <h4>Купите рекламу :( 2021</h4>
</footer>
</body>
</html>
